class RecordReader(object):
    def __init__(self, record_classes, identifier_field='record_identifier'):
        self._ident_field = identifier_field
        self._ident_len = 0
        self._types = {}

        for rc in record_classes:
            identifier = getattr(rc, identifier_field)
            self._types[identifier] = rc
            print (identifier)
            self._ident_len = max(self._ident_len, len(identifier))

    def load(self, fd):

        while 1:
            record_ident = fd.read(self._ident_len)
            if not record_ident:
                break
            record = self._types[record_ident]()
            record.read(fd)
            yield record


